#include <ltdl.h>
#include <stdio.h>

/* This dlopen() in the main executable should override any dlopen()s in
   shared libraries etc.

   If that is not the case (or the platform does not use dlopen()) then this
   test should exit 77, causing the test to SKIP.
*/
static int retcde = 77;

void * dlopen(const char *path, int mode) {
  if (!(strcmp(path,"plugin.a") && strcmp(path,"plugin.lib")))
    {
      fprintf(stderr,"Tried to open archive %s\n",path);
      retcde = 1;
    }
  else
    {
      fprintf(stderr,"Opening ... %s\n", path);
      if (retcde == 77) retcde = 0;
    }
  return NULL;
}

int
main (int argc, char* argv[])
{
  int err = 0;
  lt_dlhandle plugin_handle;

  lt_dlinit ();
  plugin_handle = lt_dlopenext (argv[1]);
  lt_dlexit ();
  return retcde;
}
